#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#include <courierauth.h>

#include "authvtoaster.h"

static int auth_vtoaster_login(const char *service, char *authdata,
                               int (*cbfunc)(struct authinfo *auth, void *data),
                               int *data)
{
	const char *user, *pass;

	if ((user = strtok(authdata, "\n")) == 0 ||
	    (pass = strtok(NULL, "\n")) == 0) {
		errno = EPERM;
		return -1;
	}

	return authvtoastercommon(user, pass, cbfunc, data);
}

int auth_vtoaster(const char *service, const char *authtype, char *authdata,
                  int (*cbfunc)(struct authinfo *auth, void *data),
                  void *data)
{
	if (strcmp(authtype, AUTHTYPE_LOGIN) == 0)
		return(auth_vtoaster_login(service, authdata,
		                           cbfunc, data));

	return -1;	                                        
}

static int auth_vtoaster_chgpwd(const char *service, const char *uid,
                               const char *oldpwd, const char *newpwd)
{
	errno = EINVAL;
	return -1;
}	  

static void auth_vtoaster_idle(void)
{
}

static void *authvtoaster_info[] = {
	"authvtoaster",
	auth_vtoaster,
	auth_vtoaster_pre,
	authvtoasterclose,
	auth_vtoaster_chgpwd,
	auth_vtoaster_idle
};

void **courier_authvtoaster_init(void)
{
	return authvtoaster_info;
}
