#ifndef __CDB_READER_H__
#define __CDB_READER_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define CDB_TYPE_READER			(cdb_reader_get_type())
#define CDB_READER(o)			(G_TYPE_CHECK_INSTANCE_CAST((o), CDB_TYPE_READER, CDBReader))
#define CDB_IS_READER(o)		(G_TYPE_CHECK_INSTANCE_TYPE((o), CDB_TYPE_READER))
#define CDB_READER_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), CDB_TYPE_READER, CDBReaderClass))

typedef struct _CDBReader	CDBReader;
typedef struct _CDBReaderClass	CDBReaderClass;

GType cdb_reader_get_type(void) G_GNUC_CONST;

CDBReader *cdb_reader_new(const gchar *filename, GError **error) G_GNUC_MALLOC;

gboolean cdb_reader_firstrec(CDBReader *reader, GError **error);
CDBDatum *cdb_reader_nextrec(CDBReader *reader, GError **error) G_GNUC_MALLOC;
CDBDatum *cdb_reader_get(CDBReader *reader, gsize klen,
                         const gchar *key, GError **error) G_GNUC_MALLOC;
CDBDatum *cdb_reader_get_string(CDBReader *reader, const gchar *key,
                                GError **error) G_GNUC_MALLOC;

G_END_DECLS

#endif /* __CDB_READER_H__ */
