#ifndef __MISC_UTILS_H__
#define __MISC_UTILS_H__

#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <sys/types.h>

#include <glib.h>
#include <glib-object.h>
#ifdef NOT_IN_LIBRARY
#	include <glib/gi18n.h>
#else
#	include <glib/gi18n-lib.h>
#endif

G_BEGIN_DECLS

G_INLINE_FUNC void v_absorb(int dummy);

#if defined(G_CAN_INLINE) || defined(__MISC_UTILS_C__)

G_INLINE_FUNC void v_absorb(int dummy)
{
	static volatile int __tmp;

	__tmp = dummy;
}

#endif

typedef enum {
	V_IO_FLAGS_CREATE	= 1<<0,
	V_IO_FLAGS_EXCL		= 1<<1,
	V_IO_FLAGS_TRUNC	= 1<<2,
	V_IO_FLAGS_APPEND	= 1<<3
} VIOFlags;

void v_init(gint *argc, gchar ***argv, const GOptionEntry *entries,
            void (*opt_setup)(GOptionContext *), const gchar *args,
            const gchar *description);
void v_init_error(const gchar *msg) G_GNUC_NORETURN;
G_CONST_RETURN gchar *v_get_hostname(void) G_GNUC_CONST;
gboolean v_drop_process_rights(const gchar *username, uid_t uid, gid_t gid,
                               GError **error);
gint v_exec(gchar **argv, GError **error);
gint v_exec_script(const gchar *script_name);
gchar *v_get_password(void);
gboolean v_mkdir_recursive(const gchar *path, guint mode,
                           guint fill_mode, GError **error);

GIOChannel *v_output_io_channel_new(const gchar *filename, VIOFlags flags,
                                    guint mode, GError **error) G_GNUC_MALLOC;
GIOStatus v_io_channel_sync(GIOChannel *io, GError **error);

G_END_DECLS

#endif /* __MISC_UTILS_H__ */
