#ifndef V_DOMAIN_INTERNAL_H
#define V_DOMAIN_INTERNAL_H

#include <glib.h>
#include <glib-object.h>

#include <misc/user.h>
#include <vdomain/vdomain.h>

G_BEGIN_DECLS

struct _VDomain {
	GObject			gobject;

	gchar			*domain;
	VUser			*user;

	GHashTable		*changeset;

	GType			auth_type;
};

struct _VDomainClass {
	GObjectClass		parent_class;

	gsize			iter_size;

	gboolean		(*setup)(VDomain *vdomain, GError **error);
	VDomainEntry *		(*lookup)(VDomain *vdomain, const gchar *user,
				          GError **Error);

	void			(*iter_init)(VDomainIter *iter);
	VDomainEntry *		(*iter_next)(VDomainIter *iter,
				             GError **error);
	void			(*iter_free)(VDomainIter *iter);

	gboolean		(*commit)(VDomain *vdomain, GError **error);
};

struct _VDomainIter {
	VDomain			*vdomain;
};

GType v_domain_cdb_get_type(void) G_GNUC_CONST;

G_END_DECLS

#endif /* V_DOMAIN_INTERNAL_H */
