#ifndef __V_DOMAIN_ENTRY_H__
#define __V_DOMAIN_ENTRY_H__

#include <time.h>

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define V_TYPE_DOMAIN_ENTRY		(v_domain_entry_get_type())
#define V_DOMAIN_ENTRY(o)		(G_TYPE_CHECK_INSTANCE_CAST((o), V_TYPE_DOMAIN_ENTRY, VDomainEntry))
#define V_IS_DOMAIN_ENTRY(o)		(G_TYPE_CHECK_INSTANCE_TYPE((o), V_TYPE_DOMAIN_ENTRY))
#define V_DOMAIN_ENTRY_GET_CLASS(inst)	(G_TYPE_INSTANCE_GET_CLASS((inst), V_TYPE_DOMAIN_ENTRY, VDomainEntryClass))

struct _VDomainEntry {
	GObject		gobject;

	/*< public, readonly >*/
	gchar		*name;
	gchar		*maildir;
	gchar		*passwd;
	gchar		**forwards;
	gchar		*personal;

	/*< public, readwrite >*/
	guint		hardquota;
	guint		softquota;
	guint		msgsize;
	guint		msgcount;
	time_t		ctime;
	time_t		expiry;

	gboolean	enabled;
};

GType v_domain_entry_get_type(void) G_GNUC_CONST;

VDomainEntry *v_domain_entry_new(const gchar *name,
                                 const gchar *maildir) G_GNUC_MALLOC;
VDomainEntry *v_domain_entry_copy(const VDomainEntry *old) G_GNUC_MALLOC;

void v_domain_entry_load_defaults(VDomainEntry *entry);
void v_domain_entry_set_name(VDomainEntry *entry, const gchar *name);
void v_domain_entry_set_maildir(VDomainEntry *entry, const gchar *maildir);
void v_domain_entry_set_password(VDomainEntry *entry, const gchar *pass);
void v_domain_entry_set_forwards_v(VDomainEntry *entry, gchar **forwards);
void v_domain_entry_set_forwards(VDomainEntry *entry, ...);
void v_domain_entry_set_personal(VDomainEntry *entry, const gchar *personal);

gchar *v_domain_entry_dump(VDomainEntry *entry) G_GNUC_PURE;
gchar *v_domain_entry_output(VDomainEntry *entry) G_GNUC_PURE;

G_END_DECLS

#endif /* __V_DOMAIN_ENTRY_H__ */
